"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tab = exports.TabView = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNativeTabView = require("react-native-tab-view");

var _reactNative = require("react-native");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const initialLayout = {
  width: _reactNative.Dimensions.get('window').width
};

const TabView = props => {
  const [index, setIndex] = (0, _react.useState)(0);
  const [routes, setRoutes] = (0, _react.useState)([]);
  const scenes = (0, _react.useRef)({});
  (0, _react.useEffect)(() => {
    if (props.children) {
      let newRoutes = [];

      _react.default.Children.forEach(props.children, (children, tabIndex) => {
        if ( /*#__PURE__*/_react.default.isValidElement(children) && children.type === Tab) {
          const newKey = children.props.key ? children.props.key : 'tab_' + tabIndex;
          scenes.current[newKey] = children;
          let newRoute = {
            key: newKey,
            icon: children.props.icon,
            title: children.props.title,
            accessible: children.props.accessible,
            accessibilityLabel: children.props.accessibilityLabel,
            testID: children.props.testID
          };
          newRoutes.push(newRoute);
        }

        setRoutes(newRoutes);
      });
    }
  }, [props.children]);

  const renderScene = ({
    route
  }) => {
    if (Math.abs(index - routes.findIndex(item => item.key === route.key)) > 2) {
      return /*#__PURE__*/_react.default.createElement(_reactNative.View, null);
    }

    if (scenes.current[route.key]) {
      return scenes.current[route.key];
    }

    return null;
  };

  return /*#__PURE__*/_react.default.createElement(_reactNativeTabView.TabView, _extends({}, props, {
    navigationState: {
      index,
      routes
    },
    renderScene: renderScene,
    onIndexChange: setIndex,
    initialLayout: initialLayout
  }));
};

exports.TabView = TabView;

const Tab = props => {
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, props.children);
};

exports.Tab = Tab;
//# sourceMappingURL=index.js.map