function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useState, useEffect, useRef } from 'react';
import { TabView as TabViewOriginal } from 'react-native-tab-view';
import { View, Dimensions } from 'react-native';
const initialLayout = {
  width: Dimensions.get('window').width
};
export const TabView = props => {
  const [index, setIndex] = useState(0);
  const [routes, setRoutes] = useState([]);
  const scenes = useRef({});
  useEffect(() => {
    if (props.children) {
      let newRoutes = [];
      React.Children.forEach(props.children, (children, tabIndex) => {
        if ( /*#__PURE__*/React.isValidElement(children) && children.type === Tab) {
          const newKey = children.props.key ? children.props.key : 'tab_' + tabIndex;
          scenes.current[newKey] = children;
          let newRoute = {
            key: newKey,
            icon: children.props.icon,
            title: children.props.title,
            accessible: children.props.accessible,
            accessibilityLabel: children.props.accessibilityLabel,
            testID: children.props.testID
          };
          newRoutes.push(newRoute);
        }

        setRoutes(newRoutes);
      });
    }
  }, [props.children]);

  const renderScene = ({
    route
  }) => {
    if (Math.abs(index - routes.findIndex(item => item.key === route.key)) > 2) {
      return /*#__PURE__*/React.createElement(View, null);
    }

    if (scenes.current[route.key]) {
      return scenes.current[route.key];
    }

    return null;
  };

  return /*#__PURE__*/React.createElement(TabViewOriginal, _extends({}, props, {
    navigationState: {
      index,
      routes
    },
    renderScene: renderScene,
    onIndexChange: setIndex,
    initialLayout: initialLayout
  }));
};
export const Tab = props => {
  return /*#__PURE__*/React.createElement(React.Fragment, null, props.children);
};
//# sourceMappingURL=index.js.map